import { convertBoundingBoxToBox, transformBoxPoints } from '../geometry/conversion.js';
import { createProjectionNode } from './create-projection-node.js';
import { DocumentProjectionNode } from './DocumentProjectionNode.js';

var documentNode;
function measureViewportBox(instance, transformPoint) {
    return convertBoundingBoxToBox(transformBoxPoints(instance.getBoundingClientRect(), transformPoint));
}
var HTMLProjectionNode = createProjectionNode({
    measureScroll: function (instance) { return ({
        x: instance.scrollLeft,
        y: instance.scrollTop,
    }); },
    measureViewportBox: measureViewportBox,
    defaultParent: function () {
        if (!documentNode) {
            documentNode = new DocumentProjectionNode();
            documentNode.mount(window);
            documentNode.setOptions({
                shouldMeasureScroll: true,
            });
        }
        return documentNode;
    },
    resetTransform: function (instance) { return (instance.style.transform = "none"); },
});

export { HTMLProjectionNode, measureViewportBox };
